declare @cesta varchar(255),
        @jmenodb varchar (255),
        @jmenolog varchar (255),
        @cestadb varchar(512),
        @cestalog varchar(512)

SELECT @cesta='D:\' /*ZDE NUTNO UPRAVIT*/
SELECT @jmenodb='DEvi0002' /*ZDE NUTNO UPRAVIT*/

SELECT @jmenolog=@jmenodb + '_log'
SELECT @cestadb='''' + @cesta + @jmenodb + '.mdf' + ''''
SELECT @cestalog='''' + @cesta + @jmenolog + '.ldf' + ''''

execute('
CREATE DATABASE ' + @jmenodb  + '
ON PRIMARY 
(NAME=' + @jmenodb + ', FILENAME=' + @cestadb + ', SIZE=24) 
LOG ON 
(NAME=' + @jmenolog + ', FILENAME=' + @cestalog + ', SIZE=24) COLLATE Czech_CI_AS
')
go
USE DEvi0002 /*ZDE NUTNO UPRAVIT*/
go
CREATE RULE YesNoRule AS @range >= -1 AND @range < 1
go
EXEC sp_addtype 'YesNo', 'int', 'not null'
EXEC sp_bindrule 'YesNoRule', 'YesNo'
go
CREATE TABLE Smlouvy (
    Cislo_dokladu varchar (30) NOT NULL ,
    Datum datetime NOT NULL ,
    Datum_uzavreni datetime NULL ,
    Doba_platnosti varchar (10) NULL ,
    Datum_zacatku_platnosti datetime NULL ,
    Datum_konce_platnosti datetime NULL ,
    Datum_ukonceni datetime NULL ,
    Dodatek YesNo NOT NULL CONSTRAINT DF_Smlouvy_Dodatek DEFAULT (0),
    Vypovedni_lhuta varchar (30) NULL,
    Kauce money NOT NULL CONSTRAINT DF_Smlouvy_Kauce DEFAULT (0),
    Vypocet_kauce varchar (255) NULL,
    Zavislost_na_inflaci varchar (255) NULL,
    Cislo_smlouvy varchar (30) NULL,
    Firma varchar (30) NULL,
    Nazev_firmy varchar (100) NULL,
    Jmeno varchar (60) NULL,
    Adresa varchar (200) NULL,
    Popis_adresy_2 varchar (20) NULL,
    Adresa_2 varchar (200) NULL,
    ICO varchar (20) NULL,
    DIC varchar (20) NULL,
    Referent varchar (30) NULL,
    Udaj_1 varchar (100) NULL,
    Udaj_2 varchar (100) NULL,
    Kategorie varchar (255) NULL,
    Poznamky varchar (255) NULL,
    Kniha varchar (30) NULL,
    Sablona varchar (30) NULL,
    Zobrazeni_souvislosti varchar (100) NOT NULL,
    upsize_ts timestamp NULL
    CONSTRAINT [Smlouvy_PK] PRIMARY KEY  NONCLUSTERED 
    (
            [Cislo_dokladu]
    )  ON [PRIMARY]
) ON [PRIMARY]

CREATE  INDEX Cislo_dokladu ON Smlouvy(Cislo_dokladu) ON [PRIMARY]
CREATE  INDEX Cislo_smlouvy ON Smlouvy(Cislo_smlouvy) ON [PRIMARY]
CREATE  INDEX Firma ON Smlouvy(Firma) ON [PRIMARY]
CREATE  INDEX Kniha ON Smlouvy(Kniha) ON [PRIMARY]
CREATE  INDEX Datum ON Smlouvy(Datum) ON [PRIMARY]
go

CREATE TABLE Smlouvy_polozky (
    Cislo_dokladu varchar (30) NOT NULL,
    Polozka_smlouvy int NOT NULL CONSTRAINT DF_Smlouvy_polozky_Polozka_smlouvy DEFAULT 0,
    Predmet_smlouvy varchar (30) NULL,
    Popis varchar (255) NULL,
    Sazba_DPH smallint NOT NULL CONSTRAINT DF_Smlouvy_polozky_Sazba_DPH DEFAULT 0,
    Mnozstvi float NOT NULL CONSTRAINT DF_Smlouvy_polozky_Mnozstvi DEFAULT 0,
    Jednotky varchar (10) NULL,
    Cena_za_jednotku money NOT NULL CONSTRAINT DF_Smlouvy_polozky_Cena_za_jednotku DEFAULT 0,
    Cena_celkem money NOT NULL CONSTRAINT DF_Smlouvy_polozky_Cena_celkem DEFAULT 0,
    Mena_polozky varchar (5) NULL,
    Platnost_od datetime NULL,
    Platnost_do datetime NULL,
    Zakazka varchar (30) NULL,
    Predkontace varchar (30) NULL,
    Zdanitelne_plneni varchar (20) NULL,
    Stredisko varchar (30) NULL,
    Pocet_dokladu smallint NOT NULL CONSTRAINT DF_Smlouvy_polozky_Pocet_dokladu DEFAULT 1,
    Interval_mezi_doklady int NULL CONSTRAINT DF_Smlouvy_polozky_Interval_mezi_doklady DEFAULT 1,
    Splatnost_dni smallint NOT NULL CONSTRAINT DF_Smlouvy_polozky_Splatnost_dni DEFAULT 0,
    Banka varchar (50) NULL,
    Pobocka varchar (50) NULL,
    Cislo_uctu varchar (20) NULL,
    Kod_banky varchar (4) NULL,
    Specificky_symbol varchar (20) NULL,
    Cilovy_Doklad varchar (30) NULL,
    Cilova_agenda varchar (30) NULL,
    Cilova_kniha varchar (30) NULL,
    [Text] varchar (255) NULL,
    Zpusob_uhrady varchar (30) NULL,
    Konstantni_symbol varchar (4) NULL,
    Konto_dokladu varchar (20) NULL,
    Urok real NOT NULL CONSTRAINT DF_Smlouvy_polozky_Urok DEFAULT 0,
    Datum_prvniho_dokladu datetime NULL,
    Castka_pro_vypocet money NOT NULL CONSTRAINT DF_Smlouvy_polozky_Castka_pro_vypocet DEFAULT 0,
    Datum_plneni_dokladu datetime NULL,
    Ve_dnech_volna_posunout varchar (50) NULL,
    Poznamka_polozky varchar(255) NULL,
    ts timestamp NULL
    CONSTRAINT [Smlouvy_polozky_PK] PRIMARY KEY  NONCLUSTERED 
    (
            [Cislo_dokladu],
            [Polozka_smlouvy]
    )  ON [PRIMARY]
) ON [PRIMARY]

CREATE  INDEX Cislo_dokladu ON Smlouvy_polozky(Cislo_dokladu) ON [PRIMARY]
CREATE  INDEX Cilova_kniha ON Smlouvy_polozky(Cilova_kniha) ON [PRIMARY]
CREATE  INDEX Platnost_do ON Smlouvy_polozky(Platnost_do) ON [PRIMARY]
CREATE  INDEX Platnost_od ON Smlouvy_polozky(Platnost_od) ON [PRIMARY]
CREATE  INDEX Predmet_platby ON Smlouvy_polozky(Predmet_smlouvy) ON [PRIMARY]
go

CREATE TABLE Kalendar_plateb (
    [ID] int IDENTITY(1,1) NOT NULL,
    Poznamka varchar (255) NULL,
    Cislo_dokladu varchar (30) NOT NULL,
    Polozka_smlouvy int NOT NULL CONSTRAINT DF_Kalendar_plateb_Polozka_smlouvy DEFAULT 0,
    Datum_vystaveni datetime NOT NULL,
    Castka money NOT NULL CONSTRAINT DF_Kalendar_plateb_Castka DEFAULT 0,
    Mena varchar (5) NULL,
    Cislo_vystaveneho_dokladu varchar (30) NULL,
    Datum_zdanitelneho_plneni datetime NULL,
    Kurs real NOT NULL CONSTRAINT DF_Kalendar_plateb_Kurs DEFAULT 1,
    Mnozstvi_meny smallint NOT NULL CONSTRAINT DF_Kalendar_plateb_Mnozstvi_meny DEFAULT 1,
    Vystavit_nyni YesNo NOT NULL CONSTRAINT DF_Kalendar_plateb_Vystavit_nyni DEFAULT 0,
    ts timestamp NULL
    CONSTRAINT [Kalendar_plateb_PK] PRIMARY KEY  NONCLUSTERED 
    (
            [ID]
    )  ON [PRIMARY]
) ON [PRIMARY]
CREATE  INDEX Cislo_dokladu ON Kalendar_plateb(Cislo_vystaveneho_dokladu) ON [PRIMARY]
CREATE  INDEX Cislo_dokladu1 ON Kalendar_plateb(Cislo_dokladu) ON [PRIMARY]
CREATE  INDEX Datum_vystaveni ON Kalendar_plateb(Datum_vystaveni) ON [PRIMARY]
CREATE  INDEX [ID] ON Kalendar_plateb([ID]) ON [PRIMARY]
CREATE  INDEX Polozka_smlouvy ON Kalendar_plateb(Polozka_smlouvy) ON [PRIMARY]
go

CREATE TABLE Katalog_plateb (
    Predmet_platby varchar (30) NOT NULL,
    Popis varchar (125) NULL,
    Sazba_DPH int NOT NULL CONSTRAINT DF_Katalog_plateb_Sazba_DPH DEFAULT 0,
    Predkontace varchar (30) NULL,
    Stredisko varchar (30) NULL,
    ts timestamp NULL
    CONSTRAINT [Katalog_plateb_PK] PRIMARY KEY  NONCLUSTERED 
    (
            Predmet_platby
    )  ON [PRIMARY]
) ON [PRIMARY]
go

CREATE TRIGGER Smlouvy_DTrig ON Smlouvy FOR DELETE AS
SET NOCOUNT ON
DELETE Smlouvy_polozky FROM deleted, Smlouvy_polozky WHERE deleted.Cislo_dokladu = Smlouvy_polozky.Cislo_dokladu
go

CREATE TRIGGER Smlouvy_UTrig ON Smlouvy FOR UPDATE AS
SET NOCOUNT ON
IF UPDATE(Cislo_dokladu)
    BEGIN
       UPDATE Smlouvy_polozky
       SET Smlouvy_polozky.Cislo_dokladu = inserted.Cislo_dokladu
       FROM Smlouvy_polozky, deleted, inserted
       WHERE deleted.Cislo_dokladu = Smlouvy_polozky.Cislo_dokladu
    END
go
CREATE TRIGGER Smlouvy_polozky_UTrig ON Smlouvy_polozky FOR UPDATE AS
SET NOCOUNT ON
IF UPDATE(Cislo_dokladu)
    BEGIN
        IF (SELECT COUNT(*) FROM inserted) != (SELECT COUNT(*) FROM Smlouvy, inserted WHERE (Smlouvy.Cislo_dokladu = inserted.Cislo_dokladu))
            BEGIN
                RAISERROR 44446 'Zznam nelze pidat nebo zmnit. Pravidla referenn integrity vyaduj souvisejc zznam v tabulce Smlouvy.'
                ROLLBACK TRANSACTION
            END
    END
IF UPDATE(Cislo_dokladu) AND NOT UPDATE(Polozka_smlouvy)
    BEGIN
       UPDATE Kalendar_plateb
       SET Kalendar_plateb.Cislo_dokladu = inserted.Cislo_dokladu
       FROM Kalendar_plateb
       inner join inserted on Kalendar_plateb.Polozka_smlouvy = inserted.Polozka_smlouvy
       inner join deleted on deleted.Cislo_dokladu = Kalendar_plateb.Cislo_dokladu AND deleted.Polozka_smlouvy = Kalendar_plateb.Polozka_smlouvy
    END
IF UPDATE(Polozka_smlouvy) AND NOT UPDATE(Cislo_dokladu)
    BEGIN
       UPDATE Kalendar_plateb
       SET Kalendar_plateb.Polozka_smlouvy = inserted.Polozka_smlouvy
       FROM Kalendar_plateb
       inner join inserted on Kalendar_plateb.Cislo_dokladu = inserted.Cislo_dokladu
       inner join deleted on deleted.Polozka_smlouvy = Kalendar_plateb.Polozka_smlouvy AND deleted.Cislo_dokladu = Kalendar_plateb.Cislo_dokladu
    END
IF UPDATE(Polozka_smlouvy) AND UPDATE(Cislo_dokladu)
    BEGIN
       UPDATE Kalendar_plateb
       SET Kalendar_plateb.Polozka_smlouvy = inserted.Polozka_smlouvy , Kalendar_plateb.Cislo_dokladu = inserted.Cislo_dokladu
       FROM Kalendar_plateb, deleted, inserted
       WHERE deleted.Cislo_dokladu = Kalendar_plateb.Cislo_dokladu AND deleted.Polozka_smlouvy = Kalendar_plateb.Polozka_smlouvy
    END
go

CREATE TRIGGER Smlouvy_polozky_DTrig ON Smlouvy_polozky FOR DELETE AS
SET NOCOUNT ON
DELETE Smlouvy_polozky FROM deleted, Smlouvy_polozky WHERE deleted.Polozka_smlouvy = Smlouvy_polozky.Polozka_smlouvy AND deleted.Cislo_dokladu = Smlouvy_polozky.Cislo_dokladu
go

CREATE TRIGGER Smlouvy_polozky_ITrig ON Smlouvy_polozky FOR INSERT AS
SET NOCOUNT ON
IF (SELECT COUNT(*) FROM inserted) != (SELECT COUNT(*) FROM Smlouvy, inserted WHERE (Smlouvy.Cislo_dokladu = inserted.Cislo_dokladu))
    BEGIN
        RAISERROR 44447 'Zznam nelze pidat nebo zmnit. Pravidla referenn integrity vyaduj souvisejc zznam v tabulce Smlouvy.'
        ROLLBACK TRANSACTION
    END
go

CREATE TRIGGER Kalendar_plateb_ITrig ON Kalendar_plateb FOR INSERT AS
SET NOCOUNT ON
IF (SELECT COUNT(*) FROM inserted) !=
   (SELECT COUNT(*) FROM Smlouvy_polozky, inserted WHERE (Smlouvy_polozky.Cislo_dokladu = inserted.Cislo_dokladu AND Smlouvy_polozky.Polozka_smlouvy = inserted.Polozka_smlouvy))
    BEGIN
        RAISERROR 44447 'Zznam nelze odstranit ani zmnit. Pravidla referenn integrity vyaduj, aby v tabulce Smlouvy_polozky existoval souvisejc zznam.'
        ROLLBACK TRANSACTION
    END
go

CREATE TRIGGER Kalendar_plateb_UTrig ON Kalendar_plateb FOR UPDATE AS
SET NOCOUNT ON
IF UPDATE(Cislo_dokladu) OR UPDATE(Polozka_smlouvy)
    BEGIN
        IF (SELECT COUNT(*) FROM inserted) !=
           (SELECT COUNT(*) FROM Smlouvy_polozky, inserted WHERE (Smlouvy_polozky.Cislo_dokladu = inserted.Cislo_dokladu AND Smlouvy_polozky.Polozka_smlouvy = inserted.Polozka_smlouvy))
            BEGIN
                RAISERROR 44446 'Zznam nelze odstranit ani zmnit. Pravidla referenn integrity vyaduj, aby v tabulce Sablony existoval souvisejc zznam.'
                ROLLBACK TRANSACTION
            END
    END
go
execute('use master
if exists (select * from sysobjects where id = object_id(N''[dbo].[spav_dejpravarw_zak_DEvi]'') and OBJECTPROPERTY(id, N''IsProcedure'') = 1)
drop procedure [dbo].[spav_dejpravarw_zak_DEvi]
execute(''CREATE procedure dbo.spav_dejpravarw_zak_DEvi
	@cislofirmy	int,
	@uzivatel	varchar(128)
AS
set nocount on
declare	@fmtData	varchar(4),
	@fmtArchiv	varchar(4),
	@counter	numeric,
	@Databaze	varchar(4),
	@Data		varchar(8),
	@DataA		varchar(8),
	@StringData		varchar(1024),
	@StringDataA		varchar(1024)

select @Databaze = ''''DEvi''''  /*Zde uvedete jmno databze zakzkovho modulu*/
if @cislofirmy > 4999
	begin
		raiserror 13000 ''''slo firmy je moc velk. Zkuste men ne 4999.''''
	end
else
	begin
		select @fmtData=''''''''
		select @fmtArchiv=cast(@cislofirmy + 5000 as varchar)
		select @counter=4-len(cast(@cislofirmy as varchar))
		while (@counter>0)
			begin
				select @fmtData=@fmtData + ''''0''''
				select @counter=@counter-1
			end
		select @fmtData=@fmtData+cast(@cislofirmy as varchar)
		select @Data= @Databaze + @fmtData
		select @DataA= @Databaze + @fmtArchiv

		select @StringData  = ''''USE '''' + @Data   + '''' if not exists(select sysusers.name, master.dbo.syslogins.name from sysusers inner join master.dbo.syslogins on sysusers.sid = master.dbo.syslogins.sid where sysusers.name = ''''''''dbo'''''''' AND master.dbo.syslogins.name = '''''''''''' + @uzivatel + '''''''''''') BEGIN if exists (select * from sysusers where name = '''''''''''' + @uzivatel + '''''''''''') execute sp_revokedbaccess '''''''''''' + @uzivatel + '''''''''''' execute sp_grantdbaccess '''''''''''' + @uzivatel + '''''''''''' execute sp_addrolemember db_datareader, '''''''''''' + @uzivatel + '''''''''''' execute sp_addrolemember db_datawriter, '''''''''''' + @uzivatel + '''''''''''' END''''
		select @StringDataA = ''''USE '''' + @DataA  + '''' if not exists(select sysusers.name, master.dbo.syslogins.name from sysusers inner join master.dbo.syslogins on sysusers.sid = master.dbo.syslogins.sid where sysusers.name = ''''''''dbo'''''''' AND master.dbo.syslogins.name = '''''''''''' + @uzivatel + '''''''''''') BEGIN if exists (select * from sysusers where name = '''''''''''' + @uzivatel + '''''''''''') execute sp_revokedbaccess '''''''''''' + @uzivatel + '''''''''''' execute sp_grantdbaccess '''''''''''' + @uzivatel + '''''''''''' execute sp_addrolemember db_datareader, '''''''''''' + @uzivatel + '''''''''''' execute sp_addrolemember db_datawriter, '''''''''''' + @uzivatel + '''''''''''' END''''

        if exists(select * from sysdatabases where [name] = @Data)
    		execute (@StringData)
        if exists(select * from sysdatabases where [name] = @DataA)
    		execute (@StringDataA)
	end'')')
go
execute('use master
if exists (select * from sysobjects where id = object_id(N''[dbo].[spav_odeberpravarw_zak_DEvi]'') and OBJECTPROPERTY(id, N''IsProcedure'') = 1)
drop procedure [dbo].[spav_odeberpravarw_zak_DEvi]
execute(''CREATE procedure dbo.spav_odeberpravarw_zak_DEvi
  @cislofirmy int,
  @uzivatel varchar(128)
AS
set nocount on
declare @fmtData  varchar(4),
  @fmtArchiv  varchar(4),
  @counter  numeric,
  @Databaze varchar(4),
  @Data   varchar(8),
  @DataA    varchar(8),
  @StringData   varchar(1024),
  @StringDataA    varchar(1024)

select @Databaze = ''''DEvi''''  /*Zde uvedete jmno databze zakzkovho modulu*/
if @cislofirmy > 4999
  begin
    raiserror 13000 ''''slo firmy je moc velk. Zkuste men ne 4999.''''
  end
else
  begin
    select @fmtData=''''''''
    select @fmtArchiv=cast(@cislofirmy + 5000 as varchar)
    select @counter=4-len(cast(@cislofirmy as varchar))
    while (@counter>0)
      begin
        select @fmtData=@fmtData + ''''0''''
        select @counter=@counter-1
      end
    select @fmtData=@fmtData+cast(@cislofirmy as varchar)
    select @Data= @Databaze + @fmtData
    select @DataA= @Databaze + @fmtArchiv

    select @StringData  = ''''USE '''' + @Data  + '''' if not exists(select sysusers.name, master.dbo.syslogins.name from sysusers inner join master.dbo.syslogins on sysusers.sid = master.dbo.syslogins.sid where sysusers.name = ''''''''dbo'''''''' AND master.dbo.syslogins.name = '''''''''''' + @uzivatel + '''''''''''') BEGIN if exists (select * from sysusers where name = '''''''''''' + @uzivatel + '''''''''''') execute sp_revokedbaccess '''''''''''' + @uzivatel + '''''''''''' END''''
    select @StringDataA = ''''USE '''' + @DataA + '''' if not exists(select sysusers.name, master.dbo.syslogins.name from sysusers inner join master.dbo.syslogins on sysusers.sid = master.dbo.syslogins.sid where sysusers.name = ''''''''dbo'''''''' AND master.dbo.syslogins.name = '''''''''''' + @uzivatel + '''''''''''') BEGIN if exists (select * from sysusers where name = '''''''''''' + @uzivatel + '''''''''''') execute sp_revokedbaccess '''''''''''' + @uzivatel + '''''''''''' END''''

        if exists(select * from sysdatabases where [name] = @Data)
        execute (@StringData)
        if exists(select * from sysdatabases where [name] = @DataA)
        execute (@StringDataA)
  end'')')
go
